/*
 * mainhashtest.c: Driver routine to demonstrate the functionality of the hash test package.
 *
 */
#include "utilHash.h"

/* we will not be using file memory and we will use the default key func */
void freeFileMem() {}
char *hashRecKeyFunc() {return NULL;}
char *allocFileMem() {return NULL;}

main()
{
  hashTable theTable;
  char input[100], command[10], *result;

  seedRandom();

  theTable = createHashTable(12, testGetString, 1);
  if(theTable == NULL)
    {
      printf("Could not allocate table\n");
      exit(-1);
    }

  while(1)
    {
      printf("Hashtest (a,d,f,r,p,x)> ");
      gets(command);
      printf("%c ",*command);
      gets(input);

      switch(*command)
      {
        case 'p':
          printStrings(theTable);
          break;

        case 'r':
          {
            long r = (random() % 2000) +1;
            long i;
            for(i=0; i<r;i++)
              {
                addToHashTable(theTable, randomString());
              }
          }
          break;

        case 'a':
          result=(char *)malloc(strlen(input)+1);
          strcpy(result, input);
          addToHashTable(theTable, result);
          printf("{%x} hashval=%d ",result,hashValueOfString(result) );
          break;

        case 'd':
          result = findInHashTable(theTable, input);
          printf("{%x} ", result); fflush(stdout);
          if(result == NULL) printf("{NOT PRESENT} ");
          else printf("{%d} ",deleteFromHashTable(theTable, result));
          break;

        case 'f':
          result = findInHashTable(theTable, input);
          if(result == NULL) printf("{NULL} ");
          else printf("{%s} ", result);
          break;

        case 'x':
          destroyHashTable(theTable);
          break;

        default:
          break;
      }
    if(*command == 'x') exit(0);
    else
      if(*command != 'p') debugPrint(theTable);
  }
}
