/* utilBag.h: general definitions for the bag utility
 */

#ifndef UTILBAG_H
#define UTILBAG_H
#include "utilHash.h"

struct bagRecStruct
{
  itemPtr data;
  int count;
};

typedef struct bagRecStruct *bagRec;


/* ***** Public Functions ***** */

EXTERNC int addToBag ARGS((
hashTable theTable,
itemPtr item,
int numTimes
));

/* negative return means attempt to delete more than were present */
EXTERNC int deleteFromBag ARGS((
hashTable theTable,
itemPtr item
));

EXTERNC char *testGetBagRec ARGS((
bagRec item
));

EXTERNC void sortMapAndDestroyBag ARGS((
hashTable theTable;
void (*aFunc)(itemPtr, char *),
char *extraArg, /* arbitrary second arg to be passed to aFunc */
int maxCases /* the maximum of elements in the histogram to return */
));

EXTERNC int countSort ARGS((
bagRec el1,
bagRec el2
));

/* PRIMITIVE: FIND: No separate function. Just use findInHashTable and
expect a bagRec in return */

/* PRIMITIVE: CREATE: No separate function. Just call createHashTable()
with an initKeyFunc that expects to be passed a bagRec; shouldFree must be
true */

/* PRIMITIVE DESTROY: Use destroyHashTable */
      
/* PRIMITIVE: MAP: Use hashTableDo with a function that expects a bagRec */


#endif
